/*
 * Copyright (c) 1997, 2010, Oracle and/or its affiliates. All rights reserved.
 * Copyright (c) 2015, 2022, Loongson Technology. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 *
 */

#ifndef CPU_LOONGARCH_RELOCINFO_LOONGARCH_HPP
#define CPU_LOONGARCH_RELOCINFO_LOONGARCH_HPP

  // machine-dependent parts of class relocInfo
 private:
  enum {
    // Since LoongArch instructions are whole words,
    // the two low-order offset bits can always be discarded.
    offset_unit        =  4,

    // imm_oop_operand vs. narrow_oop_operand
    format_width       =  2
  };

 public:

  static bool mustIterateImmediateOopsInCode() { return false; }

#endif // CPU_LOONGARCH_RELOCINFO_LOONGARCH_HPP
